<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - salidacoverage.info - /usr/include/c++/7/bits/stl_uninitialized.h</title>
  <link rel="stylesheet" type="text/css" href="../../../../../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../../../../../index.html">top level</a> - <a href="index.html">usr/include/c++/7/bits</a> - stl_uninitialized.h<span style="font-size: 80%;"> (source / <a href="stl_uninitialized.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">salidacoverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">22</td>
            <td class="headerCovTableEntry">25</td>
            <td class="headerCovTableEntryMed">88.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2019-06-10 10:35:58</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">30</td>
            <td class="headerCovTableEntry">36</td>
            <td class="headerCovTableEntryMed">83.3 %</td>
          </tr>
          <tr><td><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : // Raw memory manipulators -*- C++ -*-</a>
<span class="lineNum">       2 </span>            : 
<span class="lineNum">       3 </span>            : // Copyright (C) 2001-2017 Free Software Foundation, Inc.
<span class="lineNum">       4 </span>            : //
<span class="lineNum">       5 </span>            : // This file is part of the GNU ISO C++ Library.  This library is free
<span class="lineNum">       6 </span>            : // software; you can redistribute it and/or modify it under the
<span class="lineNum">       7 </span>            : // terms of the GNU General Public License as published by the
<span class="lineNum">       8 </span>            : // Free Software Foundation; either version 3, or (at your option)
<span class="lineNum">       9 </span>            : // any later version.
<span class="lineNum">      10 </span>            : 
<span class="lineNum">      11 </span>            : // This library is distributed in the hope that it will be useful,
<span class="lineNum">      12 </span>            : // but WITHOUT ANY WARRANTY; without even the implied warranty of
<span class="lineNum">      13 </span>            : // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<span class="lineNum">      14 </span>            : // GNU General Public License for more details.
<span class="lineNum">      15 </span>            : 
<span class="lineNum">      16 </span>            : // Under Section 7 of GPL version 3, you are granted additional
<span class="lineNum">      17 </span>            : // permissions described in the GCC Runtime Library Exception, version
<span class="lineNum">      18 </span>            : // 3.1, as published by the Free Software Foundation.
<span class="lineNum">      19 </span>            : 
<span class="lineNum">      20 </span>            : // You should have received a copy of the GNU General Public License and
<span class="lineNum">      21 </span>            : // a copy of the GCC Runtime Library Exception along with this program;
<span class="lineNum">      22 </span>            : // see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
<span class="lineNum">      23 </span>            : // &lt;http://www.gnu.org/licenses/&gt;.
<span class="lineNum">      24 </span>            : 
<span class="lineNum">      25 </span>            : /*
<span class="lineNum">      26 </span>            :  *
<span class="lineNum">      27 </span>            :  * Copyright (c) 1994
<span class="lineNum">      28 </span>            :  * Hewlett-Packard Company
<span class="lineNum">      29 </span>            :  *
<span class="lineNum">      30 </span>            :  * Permission to use, copy, modify, distribute and sell this software
<span class="lineNum">      31 </span>            :  * and its documentation for any purpose is hereby granted without fee,
<span class="lineNum">      32 </span>            :  * provided that the above copyright notice appear in all copies and
<span class="lineNum">      33 </span>            :  * that both that copyright notice and this permission notice appear
<span class="lineNum">      34 </span>            :  * in supporting documentation.  Hewlett-Packard Company makes no
<span class="lineNum">      35 </span>            :  * representations about the suitability of this software for any
<span class="lineNum">      36 </span>            :  * purpose.  It is provided &quot;as is&quot; without express or implied warranty.
<span class="lineNum">      37 </span>            :  *
<span class="lineNum">      38 </span>            :  *
<span class="lineNum">      39 </span>            :  * Copyright (c) 1996,1997
<span class="lineNum">      40 </span>            :  * Silicon Graphics Computer Systems, Inc.
<span class="lineNum">      41 </span>            :  *
<span class="lineNum">      42 </span>            :  * Permission to use, copy, modify, distribute and sell this software
<span class="lineNum">      43 </span>            :  * and its documentation for any purpose is hereby granted without fee,
<span class="lineNum">      44 </span>            :  * provided that the above copyright notice appear in all copies and
<span class="lineNum">      45 </span>            :  * that both that copyright notice and this permission notice appear
<span class="lineNum">      46 </span>            :  * in supporting documentation.  Silicon Graphics makes no
<span class="lineNum">      47 </span>            :  * representations about the suitability of this software for any
<span class="lineNum">      48 </span>            :  * purpose.  It is provided &quot;as is&quot; without express or implied warranty.
<span class="lineNum">      49 </span>            :  */
<span class="lineNum">      50 </span>            : 
<span class="lineNum">      51 </span>            : /** @file bits/stl_uninitialized.h
<span class="lineNum">      52 </span>            :  *  This is an internal header file, included by other library headers.
<span class="lineNum">      53 </span>            :  *  Do not attempt to use it directly. @headername{memory}
<span class="lineNum">      54 </span>            :  */
<span class="lineNum">      55 </span>            : 
<span class="lineNum">      56 </span>            : #ifndef _STL_UNINITIALIZED_H
<span class="lineNum">      57 </span>            : #define _STL_UNINITIALIZED_H 1
<span class="lineNum">      58 </span>            : 
<span class="lineNum">      59 </span>            : #if __cplusplus &gt; 201402L
<span class="lineNum">      60 </span>            : #include &lt;utility&gt;
<span class="lineNum">      61 </span>            : #endif
<span class="lineNum">      62 </span>            : 
<span class="lineNum">      63 </span>            : #if __cplusplus &gt;= 201103L
<span class="lineNum">      64 </span>            : #include &lt;type_traits&gt;
<span class="lineNum">      65 </span>            : #endif
<span class="lineNum">      66 </span>            : 
<span class="lineNum">      67 </span>            : namespace std _GLIBCXX_VISIBILITY(default)
<span class="lineNum">      68 </span>            : {
<span class="lineNum">      69 </span>            : _GLIBCXX_BEGIN_NAMESPACE_VERSION
<span class="lineNum">      70 </span>            : 
<span class="lineNum">      71 </span>            :   template&lt;bool _TrivialValueTypes&gt;
<span class="lineNum">      72 </span>            :     struct __uninitialized_copy
<span class="lineNum">      73 </span>            :     {
<a name="74"><span class="lineNum">      74 </span>            :       template&lt;typename _InputIterator, typename _ForwardIterator&gt;</a>
<span class="lineNum">      75 </span>            :         static _ForwardIterator
<span class="lineNum">      76 </span><span class="lineCov">      21038 :         __uninit_copy(_InputIterator __first, _InputIterator __last,</span>
<span class="lineNum">      77 </span>            :                       _ForwardIterator __result)
<span class="lineNum">      78 </span>            :         {
<span class="lineNum">      79 </span><span class="lineCov">      21038 :           _ForwardIterator __cur = __result;</span>
<span class="lineNum">      80 </span>            :           __try
<span class="lineNum">      81 </span>            :             {
<span class="lineNum">      82 </span><span class="lineCov">   31296748 :               for (; __first != __last; ++__first, (void)++__cur)</span>
<span class="lineNum">      83 </span><span class="lineCov">   15637855 :                 std::_Construct(std::__addressof(*__cur), *__first);</span>
<span class="lineNum">      84 </span><span class="lineCov">      21038 :               return __cur;</span>
<span class="lineNum">      85 </span>            :             }
<span class="lineNum">      86 </span><span class="lineNoCov">          0 :           __catch(...)</span>
<span class="lineNum">      87 </span>            :             {
<span class="lineNum">      88 </span><span class="lineNoCov">          0 :               std::_Destroy(__result, __cur);</span>
<span class="lineNum">      89 </span><span class="lineNoCov">          0 :               __throw_exception_again;</span>
<span class="lineNum">      90 </span>            :             }
<span class="lineNum">      91 </span>            :         }
<span class="lineNum">      92 </span>            :     };
<span class="lineNum">      93 </span>            : 
<span class="lineNum">      94 </span>            :   template&lt;&gt;
<span class="lineNum">      95 </span>            :     struct __uninitialized_copy&lt;true&gt;
<span class="lineNum">      96 </span>            :     {
<a name="97"><span class="lineNum">      97 </span>            :       template&lt;typename _InputIterator, typename _ForwardIterator&gt;</a>
<span class="lineNum">      98 </span>            :         static _ForwardIterator
<span class="lineNum">      99 </span><span class="lineCov">   27362351 :         __uninit_copy(_InputIterator __first, _InputIterator __last,</span>
<span class="lineNum">     100 </span>            :                       _ForwardIterator __result)
<span class="lineNum">     101 </span><span class="lineCov">   27362351 :         { return std::copy(__first, __last, __result); }</span>
<span class="lineNum">     102 </span>            :     };
<span class="lineNum">     103 </span>            : 
<span class="lineNum">     104 </span>            :   /**
<span class="lineNum">     105 </span>            :    *  @brief Copies the range [first,last) into result.
<span class="lineNum">     106 </span>            :    *  @param  __first  An input iterator.
<span class="lineNum">     107 </span>            :    *  @param  __last   An input iterator.
<span class="lineNum">     108 </span>            :    *  @param  __result An output iterator.
<span class="lineNum">     109 </span>            :    *  @return   __result + (__first - __last)
<span class="lineNum">     110 </span>            :    *
<span class="lineNum">     111 </span>            :    *  Like copy(), but does not require an initialized output range.
<span class="lineNum">     112 </span>            :   */
<a name="113"><span class="lineNum">     113 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator&gt;</a>
<span class="lineNum">     114 </span>            :     inline _ForwardIterator
<span class="lineNum">     115 </span><span class="lineCov">   27383389 :     uninitialized_copy(_InputIterator __first, _InputIterator __last,</span>
<span class="lineNum">     116 </span>            :                        _ForwardIterator __result)
<span class="lineNum">     117 </span>            :     {
<span class="lineNum">     118 </span>            :       typedef typename iterator_traits&lt;_InputIterator&gt;::value_type
<span class="lineNum">     119 </span>            :         _ValueType1;
<span class="lineNum">     120 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     121 </span>            :         _ValueType2;
<span class="lineNum">     122 </span>            : #if __cplusplus &lt; 201103L
<span class="lineNum">     123 </span>            :       const bool __assignable = true;
<span class="lineNum">     124 </span>            : #else
<span class="lineNum">     125 </span>            :       // trivial types can have deleted assignment
<span class="lineNum">     126 </span>            :       typedef typename iterator_traits&lt;_InputIterator&gt;::reference _RefType1;
<span class="lineNum">     127 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::reference _RefType2;
<span class="lineNum">     128 </span><span class="lineCov">   27383389 :       const bool __assignable = is_assignable&lt;_RefType2, _RefType1&gt;::value;</span>
<span class="lineNum">     129 </span>            : #endif
<span class="lineNum">     130 </span>            : 
<span class="lineNum">     131 </span>            :       return std::__uninitialized_copy&lt;__is_trivial(_ValueType1)
<span class="lineNum">     132 </span>            :                                        &amp;&amp; __is_trivial(_ValueType2)
<span class="lineNum">     133 </span>            :                                        &amp;&amp; __assignable&gt;::
<span class="lineNum">     134 </span><span class="lineCov">   27383389 :         __uninit_copy(__first, __last, __result);</span>
<span class="lineNum">     135 </span>            :     }
<span class="lineNum">     136 </span>            : 
<span class="lineNum">     137 </span>            : 
<span class="lineNum">     138 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     139 </span>            :     struct __uninitialized_fill
<span class="lineNum">     140 </span>            :     {
<span class="lineNum">     141 </span>            :       template&lt;typename _ForwardIterator, typename _Tp&gt;
<span class="lineNum">     142 </span>            :         static void
<span class="lineNum">     143 </span>            :         __uninit_fill(_ForwardIterator __first, _ForwardIterator __last,
<span class="lineNum">     144 </span>            :                       const _Tp&amp; __x)
<span class="lineNum">     145 </span>            :         {
<span class="lineNum">     146 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     147 </span>            :           __try
<span class="lineNum">     148 </span>            :             {
<span class="lineNum">     149 </span>            :               for (; __cur != __last; ++__cur)
<span class="lineNum">     150 </span>            :                 std::_Construct(std::__addressof(*__cur), __x);
<span class="lineNum">     151 </span>            :             }
<span class="lineNum">     152 </span>            :           __catch(...)
<span class="lineNum">     153 </span>            :             {
<span class="lineNum">     154 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     155 </span>            :               __throw_exception_again;
<span class="lineNum">     156 </span>            :             }
<span class="lineNum">     157 </span>            :         }
<span class="lineNum">     158 </span>            :     };
<span class="lineNum">     159 </span>            : 
<span class="lineNum">     160 </span>            :   template&lt;&gt;
<span class="lineNum">     161 </span>            :     struct __uninitialized_fill&lt;true&gt;
<span class="lineNum">     162 </span>            :     {
<span class="lineNum">     163 </span>            :       template&lt;typename _ForwardIterator, typename _Tp&gt;
<span class="lineNum">     164 </span>            :         static void
<span class="lineNum">     165 </span>            :         __uninit_fill(_ForwardIterator __first, _ForwardIterator __last,
<span class="lineNum">     166 </span>            :                       const _Tp&amp; __x)
<span class="lineNum">     167 </span>            :         { std::fill(__first, __last, __x); }
<span class="lineNum">     168 </span>            :     };
<span class="lineNum">     169 </span>            : 
<span class="lineNum">     170 </span>            :   /**
<span class="lineNum">     171 </span>            :    *  @brief Copies the value x into the range [first,last).
<span class="lineNum">     172 </span>            :    *  @param  __first  An input iterator.
<span class="lineNum">     173 </span>            :    *  @param  __last   An input iterator.
<span class="lineNum">     174 </span>            :    *  @param  __x      The source value.
<span class="lineNum">     175 </span>            :    *  @return   Nothing.
<span class="lineNum">     176 </span>            :    *
<span class="lineNum">     177 </span>            :    *  Like fill(), but does not require an initialized output range.
<span class="lineNum">     178 </span>            :   */
<span class="lineNum">     179 </span>            :   template&lt;typename _ForwardIterator, typename _Tp&gt;
<span class="lineNum">     180 </span>            :     inline void
<span class="lineNum">     181 </span>            :     uninitialized_fill(_ForwardIterator __first, _ForwardIterator __last,
<span class="lineNum">     182 </span>            :                        const _Tp&amp; __x)
<span class="lineNum">     183 </span>            :     {
<span class="lineNum">     184 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     185 </span>            :         _ValueType;
<span class="lineNum">     186 </span>            : #if __cplusplus &lt; 201103L
<span class="lineNum">     187 </span>            :       const bool __assignable = true;
<span class="lineNum">     188 </span>            : #else
<span class="lineNum">     189 </span>            :       // trivial types can have deleted assignment
<span class="lineNum">     190 </span>            :       const bool __assignable = is_copy_assignable&lt;_ValueType&gt;::value;
<span class="lineNum">     191 </span>            : #endif
<span class="lineNum">     192 </span>            : 
<span class="lineNum">     193 </span>            :       std::__uninitialized_fill&lt;__is_trivial(_ValueType) &amp;&amp; __assignable&gt;::
<span class="lineNum">     194 </span>            :         __uninit_fill(__first, __last, __x);
<span class="lineNum">     195 </span>            :     }
<span class="lineNum">     196 </span>            : 
<span class="lineNum">     197 </span>            : 
<span class="lineNum">     198 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     199 </span>            :     struct __uninitialized_fill_n
<span class="lineNum">     200 </span>            :     {
<span class="lineNum">     201 </span>            :       template&lt;typename _ForwardIterator, typename _Size, typename _Tp&gt;
<span class="lineNum">     202 </span>            :         static _ForwardIterator
<span class="lineNum">     203 </span>            :         __uninit_fill_n(_ForwardIterator __first, _Size __n,
<span class="lineNum">     204 </span>            :                         const _Tp&amp; __x)
<span class="lineNum">     205 </span>            :         {
<span class="lineNum">     206 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     207 </span>            :           __try
<span class="lineNum">     208 </span>            :             {
<span class="lineNum">     209 </span>            :               for (; __n &gt; 0; --__n, ++__cur)
<span class="lineNum">     210 </span>            :                 std::_Construct(std::__addressof(*__cur), __x);
<span class="lineNum">     211 </span>            :               return __cur;
<span class="lineNum">     212 </span>            :             }
<span class="lineNum">     213 </span>            :           __catch(...)
<span class="lineNum">     214 </span>            :             {
<span class="lineNum">     215 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     216 </span>            :               __throw_exception_again;
<span class="lineNum">     217 </span>            :             }
<span class="lineNum">     218 </span>            :         }
<span class="lineNum">     219 </span>            :     };
<span class="lineNum">     220 </span>            : 
<span class="lineNum">     221 </span>            :   template&lt;&gt;
<span class="lineNum">     222 </span>            :     struct __uninitialized_fill_n&lt;true&gt;
<span class="lineNum">     223 </span>            :     {
<span class="lineNum">     224 </span>            :       template&lt;typename _ForwardIterator, typename _Size, typename _Tp&gt;
<span class="lineNum">     225 </span>            :         static _ForwardIterator
<span class="lineNum">     226 </span>            :         __uninit_fill_n(_ForwardIterator __first, _Size __n,
<span class="lineNum">     227 </span>            :                         const _Tp&amp; __x)
<span class="lineNum">     228 </span>            :         { return std::fill_n(__first, __n, __x); }
<span class="lineNum">     229 </span>            :     };
<span class="lineNum">     230 </span>            : 
<span class="lineNum">     231 </span>            :    // _GLIBCXX_RESOLVE_LIB_DEFECTS
<span class="lineNum">     232 </span>            :    // DR 1339. uninitialized_fill_n should return the end of its range
<span class="lineNum">     233 </span>            :   /**
<span class="lineNum">     234 </span>            :    *  @brief Copies the value x into the range [first,first+n).
<span class="lineNum">     235 </span>            :    *  @param  __first  An input iterator.
<span class="lineNum">     236 </span>            :    *  @param  __n      The number of copies to make.
<span class="lineNum">     237 </span>            :    *  @param  __x      The source value.
<span class="lineNum">     238 </span>            :    *  @return   Nothing.
<span class="lineNum">     239 </span>            :    *
<span class="lineNum">     240 </span>            :    *  Like fill_n(), but does not require an initialized output range.
<span class="lineNum">     241 </span>            :   */
<span class="lineNum">     242 </span>            :   template&lt;typename _ForwardIterator, typename _Size, typename _Tp&gt;
<span class="lineNum">     243 </span>            :     inline _ForwardIterator
<span class="lineNum">     244 </span>            :     uninitialized_fill_n(_ForwardIterator __first, _Size __n, const _Tp&amp; __x)
<span class="lineNum">     245 </span>            :     {
<span class="lineNum">     246 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     247 </span>            :         _ValueType;
<span class="lineNum">     248 </span>            : #if __cplusplus &lt; 201103L
<span class="lineNum">     249 </span>            :       const bool __assignable = true;
<span class="lineNum">     250 </span>            : #else
<span class="lineNum">     251 </span>            :       // trivial types can have deleted assignment
<span class="lineNum">     252 </span>            :       const bool __assignable = is_copy_assignable&lt;_ValueType&gt;::value;
<span class="lineNum">     253 </span>            : #endif
<span class="lineNum">     254 </span>            :       return __uninitialized_fill_n&lt;__is_trivial(_ValueType) &amp;&amp; __assignable&gt;::
<span class="lineNum">     255 </span>            :         __uninit_fill_n(__first, __n, __x);
<span class="lineNum">     256 </span>            :     }
<span class="lineNum">     257 </span>            : 
<span class="lineNum">     258 </span>            :   // Extensions: versions of uninitialized_copy, uninitialized_fill,
<span class="lineNum">     259 </span>            :   //  and uninitialized_fill_n that take an allocator parameter.
<span class="lineNum">     260 </span>            :   //  We dispatch back to the standard versions when we're given the
<span class="lineNum">     261 </span>            :   //  default allocator.  For nondefault allocators we do not use 
<span class="lineNum">     262 </span>            :   //  any of the POD optimizations.
<span class="lineNum">     263 </span>            : 
<span class="lineNum">     264 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator,
<span class="lineNum">     265 </span>            :            typename _Allocator&gt;
<span class="lineNum">     266 </span>            :     _ForwardIterator
<span class="lineNum">     267 </span>            :     __uninitialized_copy_a(_InputIterator __first, _InputIterator __last,
<span class="lineNum">     268 </span>            :                            _ForwardIterator __result, _Allocator&amp; __alloc)
<span class="lineNum">     269 </span>            :     {
<span class="lineNum">     270 </span>            :       _ForwardIterator __cur = __result;
<span class="lineNum">     271 </span>            :       __try
<span class="lineNum">     272 </span>            :         {
<span class="lineNum">     273 </span>            :           typedef __gnu_cxx::__alloc_traits&lt;_Allocator&gt; __traits;
<span class="lineNum">     274 </span>            :           for (; __first != __last; ++__first, (void)++__cur)
<span class="lineNum">     275 </span>            :             __traits::construct(__alloc, std::__addressof(*__cur), *__first);
<span class="lineNum">     276 </span>            :           return __cur;
<span class="lineNum">     277 </span>            :         }
<span class="lineNum">     278 </span>            :       __catch(...)
<span class="lineNum">     279 </span>            :         {
<span class="lineNum">     280 </span>            :           std::_Destroy(__result, __cur, __alloc);
<span class="lineNum">     281 </span>            :           __throw_exception_again;
<span class="lineNum">     282 </span>            :         }
<span class="lineNum">     283 </span>            :     }
<span class="lineNum">     284 </span>            : 
<a name="285"><span class="lineNum">     285 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator, typename _Tp&gt;</a>
<span class="lineNum">     286 </span>            :     inline _ForwardIterator
<span class="lineNum">     287 </span><span class="lineCov">   27383389 :     __uninitialized_copy_a(_InputIterator __first, _InputIterator __last,</span>
<span class="lineNum">     288 </span>            :                            _ForwardIterator __result, allocator&lt;_Tp&gt;&amp;)
<span class="lineNum">     289 </span><span class="lineCov">   27383389 :     { return std::uninitialized_copy(__first, __last, __result); }</span>
<span class="lineNum">     290 </span>            : 
<span class="lineNum">     291 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator,
<span class="lineNum">     292 </span>            :            typename _Allocator&gt;
<span class="lineNum">     293 </span>            :     inline _ForwardIterator
<span class="lineNum">     294 </span>            :     __uninitialized_move_a(_InputIterator __first, _InputIterator __last,
<span class="lineNum">     295 </span>            :                            _ForwardIterator __result, _Allocator&amp; __alloc)
<span class="lineNum">     296 </span>            :     {
<span class="lineNum">     297 </span>            :       return std::__uninitialized_copy_a(_GLIBCXX_MAKE_MOVE_ITERATOR(__first),
<span class="lineNum">     298 </span>            :                                          _GLIBCXX_MAKE_MOVE_ITERATOR(__last),
<span class="lineNum">     299 </span>            :                                          __result, __alloc);
<span class="lineNum">     300 </span>            :     }
<span class="lineNum">     301 </span>            : 
<span class="lineNum">     302 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator,
<a name="303"><span class="lineNum">     303 </span>            :            typename _Allocator&gt;</a>
<span class="lineNum">     304 </span>            :     inline _ForwardIterator
<span class="lineNum">     305 </span><span class="lineCov">     826678 :     __uninitialized_move_if_noexcept_a(_InputIterator __first,</span>
<span class="lineNum">     306 </span>            :                                        _InputIterator __last,
<span class="lineNum">     307 </span>            :                                        _ForwardIterator __result,
<span class="lineNum">     308 </span>            :                                        _Allocator&amp; __alloc)
<span class="lineNum">     309 </span>            :     {
<span class="lineNum">     310 </span>            :       return std::__uninitialized_copy_a
<span class="lineNum">     311 </span><span class="lineCov">     826678 :         (_GLIBCXX_MAKE_MOVE_IF_NOEXCEPT_ITERATOR(__first),</span>
<span class="lineNum">     312 </span><span class="lineCov">     826678 :          _GLIBCXX_MAKE_MOVE_IF_NOEXCEPT_ITERATOR(__last), __result, __alloc);</span>
<span class="lineNum">     313 </span>            :     }
<span class="lineNum">     314 </span>            : 
<span class="lineNum">     315 </span>            :   template&lt;typename _ForwardIterator, typename _Tp, typename _Allocator&gt;
<span class="lineNum">     316 </span>            :     void
<span class="lineNum">     317 </span>            :     __uninitialized_fill_a(_ForwardIterator __first, _ForwardIterator __last,
<span class="lineNum">     318 </span>            :                            const _Tp&amp; __x, _Allocator&amp; __alloc)
<span class="lineNum">     319 </span>            :     {
<span class="lineNum">     320 </span>            :       _ForwardIterator __cur = __first;
<span class="lineNum">     321 </span>            :       __try
<span class="lineNum">     322 </span>            :         {
<span class="lineNum">     323 </span>            :           typedef __gnu_cxx::__alloc_traits&lt;_Allocator&gt; __traits;
<span class="lineNum">     324 </span>            :           for (; __cur != __last; ++__cur)
<span class="lineNum">     325 </span>            :             __traits::construct(__alloc, std::__addressof(*__cur), __x);
<span class="lineNum">     326 </span>            :         }
<span class="lineNum">     327 </span>            :       __catch(...)
<span class="lineNum">     328 </span>            :         {
<span class="lineNum">     329 </span>            :           std::_Destroy(__first, __cur, __alloc);
<span class="lineNum">     330 </span>            :           __throw_exception_again;
<span class="lineNum">     331 </span>            :         }
<span class="lineNum">     332 </span>            :     }
<span class="lineNum">     333 </span>            : 
<span class="lineNum">     334 </span>            :   template&lt;typename _ForwardIterator, typename _Tp, typename _Tp2&gt;
<span class="lineNum">     335 </span>            :     inline void
<span class="lineNum">     336 </span>            :     __uninitialized_fill_a(_ForwardIterator __first, _ForwardIterator __last,
<span class="lineNum">     337 </span>            :                            const _Tp&amp; __x, allocator&lt;_Tp2&gt;&amp;)
<span class="lineNum">     338 </span>            :     { std::uninitialized_fill(__first, __last, __x); }
<span class="lineNum">     339 </span>            : 
<span class="lineNum">     340 </span>            :   template&lt;typename _ForwardIterator, typename _Size, typename _Tp,
<span class="lineNum">     341 </span>            :            typename _Allocator&gt;
<span class="lineNum">     342 </span>            :     _ForwardIterator
<span class="lineNum">     343 </span>            :     __uninitialized_fill_n_a(_ForwardIterator __first, _Size __n, 
<span class="lineNum">     344 </span>            :                              const _Tp&amp; __x, _Allocator&amp; __alloc)
<span class="lineNum">     345 </span>            :     {
<span class="lineNum">     346 </span>            :       _ForwardIterator __cur = __first;
<span class="lineNum">     347 </span>            :       __try
<span class="lineNum">     348 </span>            :         {
<span class="lineNum">     349 </span>            :           typedef __gnu_cxx::__alloc_traits&lt;_Allocator&gt; __traits;
<span class="lineNum">     350 </span>            :           for (; __n &gt; 0; --__n, ++__cur)
<span class="lineNum">     351 </span>            :             __traits::construct(__alloc, std::__addressof(*__cur), __x);
<span class="lineNum">     352 </span>            :           return __cur;
<span class="lineNum">     353 </span>            :         }
<span class="lineNum">     354 </span>            :       __catch(...)
<span class="lineNum">     355 </span>            :         {
<span class="lineNum">     356 </span>            :           std::_Destroy(__first, __cur, __alloc);
<span class="lineNum">     357 </span>            :           __throw_exception_again;
<span class="lineNum">     358 </span>            :         }
<span class="lineNum">     359 </span>            :     }
<span class="lineNum">     360 </span>            : 
<span class="lineNum">     361 </span>            :   template&lt;typename _ForwardIterator, typename _Size, typename _Tp,
<span class="lineNum">     362 </span>            :            typename _Tp2&gt;
<span class="lineNum">     363 </span>            :     inline _ForwardIterator
<span class="lineNum">     364 </span>            :     __uninitialized_fill_n_a(_ForwardIterator __first, _Size __n, 
<span class="lineNum">     365 </span>            :                              const _Tp&amp; __x, allocator&lt;_Tp2&gt;&amp;)
<span class="lineNum">     366 </span>            :     { return std::uninitialized_fill_n(__first, __n, __x); }
<span class="lineNum">     367 </span>            : 
<span class="lineNum">     368 </span>            : 
<span class="lineNum">     369 </span>            :   // Extensions: __uninitialized_copy_move, __uninitialized_move_copy,
<span class="lineNum">     370 </span>            :   // __uninitialized_fill_move, __uninitialized_move_fill.
<span class="lineNum">     371 </span>            :   // All of these algorithms take a user-supplied allocator, which is used
<span class="lineNum">     372 </span>            :   // for construction and destruction.
<span class="lineNum">     373 </span>            : 
<span class="lineNum">     374 </span>            :   // __uninitialized_copy_move
<span class="lineNum">     375 </span>            :   // Copies [first1, last1) into [result, result + (last1 - first1)), and
<span class="lineNum">     376 </span>            :   //  move [first2, last2) into
<span class="lineNum">     377 </span>            :   //  [result, result + (last1 - first1) + (last2 - first2)).
<span class="lineNum">     378 </span>            :   template&lt;typename _InputIterator1, typename _InputIterator2,
<span class="lineNum">     379 </span>            :            typename _ForwardIterator, typename _Allocator&gt;
<span class="lineNum">     380 </span>            :     inline _ForwardIterator
<span class="lineNum">     381 </span>            :     __uninitialized_copy_move(_InputIterator1 __first1,
<span class="lineNum">     382 </span>            :                               _InputIterator1 __last1,
<span class="lineNum">     383 </span>            :                               _InputIterator2 __first2,
<span class="lineNum">     384 </span>            :                               _InputIterator2 __last2,
<span class="lineNum">     385 </span>            :                               _ForwardIterator __result,
<span class="lineNum">     386 </span>            :                               _Allocator&amp; __alloc)
<span class="lineNum">     387 </span>            :     {
<span class="lineNum">     388 </span>            :       _ForwardIterator __mid = std::__uninitialized_copy_a(__first1, __last1,
<span class="lineNum">     389 </span>            :                                                            __result,
<span class="lineNum">     390 </span>            :                                                            __alloc);
<span class="lineNum">     391 </span>            :       __try
<span class="lineNum">     392 </span>            :         {
<span class="lineNum">     393 </span>            :           return std::__uninitialized_move_a(__first2, __last2, __mid, __alloc);
<span class="lineNum">     394 </span>            :         }
<span class="lineNum">     395 </span>            :       __catch(...)
<span class="lineNum">     396 </span>            :         {
<span class="lineNum">     397 </span>            :           std::_Destroy(__result, __mid, __alloc);
<span class="lineNum">     398 </span>            :           __throw_exception_again;
<span class="lineNum">     399 </span>            :         }
<span class="lineNum">     400 </span>            :     }
<span class="lineNum">     401 </span>            : 
<span class="lineNum">     402 </span>            :   // __uninitialized_move_copy
<span class="lineNum">     403 </span>            :   // Moves [first1, last1) into [result, result + (last1 - first1)), and
<span class="lineNum">     404 </span>            :   //  copies [first2, last2) into
<span class="lineNum">     405 </span>            :   //  [result, result + (last1 - first1) + (last2 - first2)).
<span class="lineNum">     406 </span>            :   template&lt;typename _InputIterator1, typename _InputIterator2,
<span class="lineNum">     407 </span>            :            typename _ForwardIterator, typename _Allocator&gt;
<span class="lineNum">     408 </span>            :     inline _ForwardIterator
<span class="lineNum">     409 </span>            :     __uninitialized_move_copy(_InputIterator1 __first1,
<span class="lineNum">     410 </span>            :                               _InputIterator1 __last1,
<span class="lineNum">     411 </span>            :                               _InputIterator2 __first2,
<span class="lineNum">     412 </span>            :                               _InputIterator2 __last2,
<span class="lineNum">     413 </span>            :                               _ForwardIterator __result,
<span class="lineNum">     414 </span>            :                               _Allocator&amp; __alloc)
<span class="lineNum">     415 </span>            :     {
<span class="lineNum">     416 </span>            :       _ForwardIterator __mid = std::__uninitialized_move_a(__first1, __last1,
<span class="lineNum">     417 </span>            :                                                            __result,
<span class="lineNum">     418 </span>            :                                                            __alloc);
<span class="lineNum">     419 </span>            :       __try
<span class="lineNum">     420 </span>            :         {
<span class="lineNum">     421 </span>            :           return std::__uninitialized_copy_a(__first2, __last2, __mid, __alloc);
<span class="lineNum">     422 </span>            :         }
<span class="lineNum">     423 </span>            :       __catch(...)
<span class="lineNum">     424 </span>            :         {
<span class="lineNum">     425 </span>            :           std::_Destroy(__result, __mid, __alloc);
<span class="lineNum">     426 </span>            :           __throw_exception_again;
<span class="lineNum">     427 </span>            :         }
<span class="lineNum">     428 </span>            :     }
<span class="lineNum">     429 </span>            :   
<span class="lineNum">     430 </span>            :   // __uninitialized_fill_move
<span class="lineNum">     431 </span>            :   // Fills [result, mid) with x, and moves [first, last) into
<span class="lineNum">     432 </span>            :   //  [mid, mid + (last - first)).
<span class="lineNum">     433 </span>            :   template&lt;typename _ForwardIterator, typename _Tp, typename _InputIterator,
<span class="lineNum">     434 </span>            :            typename _Allocator&gt;
<span class="lineNum">     435 </span>            :     inline _ForwardIterator
<span class="lineNum">     436 </span>            :     __uninitialized_fill_move(_ForwardIterator __result, _ForwardIterator __mid,
<span class="lineNum">     437 </span>            :                               const _Tp&amp; __x, _InputIterator __first,
<span class="lineNum">     438 </span>            :                               _InputIterator __last, _Allocator&amp; __alloc)
<span class="lineNum">     439 </span>            :     {
<span class="lineNum">     440 </span>            :       std::__uninitialized_fill_a(__result, __mid, __x, __alloc);
<span class="lineNum">     441 </span>            :       __try
<span class="lineNum">     442 </span>            :         {
<span class="lineNum">     443 </span>            :           return std::__uninitialized_move_a(__first, __last, __mid, __alloc);
<span class="lineNum">     444 </span>            :         }
<span class="lineNum">     445 </span>            :       __catch(...)
<span class="lineNum">     446 </span>            :         {
<span class="lineNum">     447 </span>            :           std::_Destroy(__result, __mid, __alloc);
<span class="lineNum">     448 </span>            :           __throw_exception_again;
<span class="lineNum">     449 </span>            :         }
<span class="lineNum">     450 </span>            :     }
<span class="lineNum">     451 </span>            : 
<span class="lineNum">     452 </span>            :   // __uninitialized_move_fill
<span class="lineNum">     453 </span>            :   // Moves [first1, last1) into [first2, first2 + (last1 - first1)), and
<span class="lineNum">     454 </span>            :   //  fills [first2 + (last1 - first1), last2) with x.
<span class="lineNum">     455 </span>            :   template&lt;typename _InputIterator, typename _ForwardIterator, typename _Tp,
<span class="lineNum">     456 </span>            :            typename _Allocator&gt;
<span class="lineNum">     457 </span>            :     inline void
<span class="lineNum">     458 </span>            :     __uninitialized_move_fill(_InputIterator __first1, _InputIterator __last1,
<span class="lineNum">     459 </span>            :                               _ForwardIterator __first2,
<span class="lineNum">     460 </span>            :                               _ForwardIterator __last2, const _Tp&amp; __x,
<span class="lineNum">     461 </span>            :                               _Allocator&amp; __alloc)
<span class="lineNum">     462 </span>            :     {
<span class="lineNum">     463 </span>            :       _ForwardIterator __mid2 = std::__uninitialized_move_a(__first1, __last1,
<span class="lineNum">     464 </span>            :                                                             __first2,
<span class="lineNum">     465 </span>            :                                                             __alloc);
<span class="lineNum">     466 </span>            :       __try
<span class="lineNum">     467 </span>            :         {
<span class="lineNum">     468 </span>            :           std::__uninitialized_fill_a(__mid2, __last2, __x, __alloc);
<span class="lineNum">     469 </span>            :         }
<span class="lineNum">     470 </span>            :       __catch(...)
<span class="lineNum">     471 </span>            :         {
<span class="lineNum">     472 </span>            :           std::_Destroy(__first2, __mid2, __alloc);
<span class="lineNum">     473 </span>            :           __throw_exception_again;
<span class="lineNum">     474 </span>            :         }
<span class="lineNum">     475 </span>            :     }
<span class="lineNum">     476 </span>            : 
<span class="lineNum">     477 </span>            : #if __cplusplus &gt;= 201103L
<span class="lineNum">     478 </span>            :   // Extensions: __uninitialized_default, __uninitialized_default_n,
<span class="lineNum">     479 </span>            :   // __uninitialized_default_a, __uninitialized_default_n_a.
<span class="lineNum">     480 </span>            : 
<span class="lineNum">     481 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     482 </span>            :     struct __uninitialized_default_1
<span class="lineNum">     483 </span>            :     {
<span class="lineNum">     484 </span>            :       template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     485 </span>            :         static void
<span class="lineNum">     486 </span>            :         __uninit_default(_ForwardIterator __first, _ForwardIterator __last)
<span class="lineNum">     487 </span>            :         {
<span class="lineNum">     488 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     489 </span>            :           __try
<span class="lineNum">     490 </span>            :             {
<span class="lineNum">     491 </span>            :               for (; __cur != __last; ++__cur)
<span class="lineNum">     492 </span>            :                 std::_Construct(std::__addressof(*__cur));
<span class="lineNum">     493 </span>            :             }
<span class="lineNum">     494 </span>            :           __catch(...)
<span class="lineNum">     495 </span>            :             {
<span class="lineNum">     496 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     497 </span>            :               __throw_exception_again;
<span class="lineNum">     498 </span>            :             }
<span class="lineNum">     499 </span>            :         }
<span class="lineNum">     500 </span>            :     };
<span class="lineNum">     501 </span>            : 
<span class="lineNum">     502 </span>            :   template&lt;&gt;
<span class="lineNum">     503 </span>            :     struct __uninitialized_default_1&lt;true&gt;
<span class="lineNum">     504 </span>            :     {
<span class="lineNum">     505 </span>            :       template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     506 </span>            :         static void
<span class="lineNum">     507 </span>            :         __uninit_default(_ForwardIterator __first, _ForwardIterator __last)
<span class="lineNum">     508 </span>            :         {
<span class="lineNum">     509 </span>            :           typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     510 </span>            :             _ValueType;
<span class="lineNum">     511 </span>            : 
<span class="lineNum">     512 </span>            :           std::fill(__first, __last, _ValueType());
<span class="lineNum">     513 </span>            :         }
<span class="lineNum">     514 </span>            :     };
<span class="lineNum">     515 </span>            : 
<span class="lineNum">     516 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     517 </span>            :     struct __uninitialized_default_n_1
<span class="lineNum">     518 </span>            :     {
<span class="lineNum">     519 </span>            :       template&lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     520 </span>            :         static _ForwardIterator
<span class="lineNum">     521 </span>            :         __uninit_default_n(_ForwardIterator __first, _Size __n)
<span class="lineNum">     522 </span>            :         {
<span class="lineNum">     523 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     524 </span>            :           __try
<span class="lineNum">     525 </span>            :             {
<span class="lineNum">     526 </span>            :               for (; __n &gt; 0; --__n, ++__cur)
<span class="lineNum">     527 </span>            :                 std::_Construct(std::__addressof(*__cur));
<span class="lineNum">     528 </span>            :               return __cur;
<span class="lineNum">     529 </span>            :             }
<span class="lineNum">     530 </span>            :           __catch(...)
<span class="lineNum">     531 </span>            :             {
<span class="lineNum">     532 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     533 </span>            :               __throw_exception_again;
<span class="lineNum">     534 </span>            :             }
<span class="lineNum">     535 </span>            :         }
<span class="lineNum">     536 </span>            :     };
<span class="lineNum">     537 </span>            : 
<span class="lineNum">     538 </span>            :   template&lt;&gt;
<span class="lineNum">     539 </span>            :     struct __uninitialized_default_n_1&lt;true&gt;
<span class="lineNum">     540 </span>            :     {
<a name="541"><span class="lineNum">     541 </span>            :       template&lt;typename _ForwardIterator, typename _Size&gt;</a>
<span class="lineNum">     542 </span>            :         static _ForwardIterator
<span class="lineNum">     543 </span><span class="lineCov">          4 :         __uninit_default_n(_ForwardIterator __first, _Size __n)</span>
<span class="lineNum">     544 </span>            :         {
<span class="lineNum">     545 </span>            :           typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     546 </span>            :             _ValueType;
<span class="lineNum">     547 </span>            : 
<span class="lineNum">     548 </span><span class="lineCov">          4 :           return std::fill_n(__first, __n, _ValueType());</span>
<span class="lineNum">     549 </span>            :         }
<span class="lineNum">     550 </span>            :     };
<span class="lineNum">     551 </span>            : 
<span class="lineNum">     552 </span>            :   // __uninitialized_default
<span class="lineNum">     553 </span>            :   // Fills [first, last) with std::distance(first, last) default
<span class="lineNum">     554 </span>            :   // constructed value_types(s).
<span class="lineNum">     555 </span>            :   template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     556 </span>            :     inline void
<span class="lineNum">     557 </span>            :     __uninitialized_default(_ForwardIterator __first,
<span class="lineNum">     558 </span>            :                             _ForwardIterator __last)
<span class="lineNum">     559 </span>            :     {
<span class="lineNum">     560 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     561 </span>            :         _ValueType;
<span class="lineNum">     562 </span>            :       // trivial types can have deleted assignment
<span class="lineNum">     563 </span>            :       const bool __assignable = is_copy_assignable&lt;_ValueType&gt;::value;
<span class="lineNum">     564 </span>            : 
<span class="lineNum">     565 </span>            :       std::__uninitialized_default_1&lt;__is_trivial(_ValueType)
<span class="lineNum">     566 </span>            :                                      &amp;&amp; __assignable&gt;::
<span class="lineNum">     567 </span>            :         __uninit_default(__first, __last);
<span class="lineNum">     568 </span>            :     }
<span class="lineNum">     569 </span>            : 
<span class="lineNum">     570 </span>            :   // __uninitialized_default_n
<span class="lineNum">     571 </span>            :   // Fills [first, first + n) with n default constructed value_type(s).
<a name="572"><span class="lineNum">     572 </span>            :   template&lt;typename _ForwardIterator, typename _Size&gt;</a>
<span class="lineNum">     573 </span>            :     inline _ForwardIterator
<span class="lineNum">     574 </span><span class="lineCov">          4 :     __uninitialized_default_n(_ForwardIterator __first, _Size __n)</span>
<span class="lineNum">     575 </span>            :     {
<span class="lineNum">     576 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     577 </span>            :         _ValueType;
<span class="lineNum">     578 </span>            :       // trivial types can have deleted assignment
<span class="lineNum">     579 </span><span class="lineCov">          4 :       const bool __assignable = is_copy_assignable&lt;_ValueType&gt;::value;</span>
<span class="lineNum">     580 </span>            : 
<span class="lineNum">     581 </span>            :       return __uninitialized_default_n_1&lt;__is_trivial(_ValueType)
<span class="lineNum">     582 </span>            :                                        &amp;&amp; __assignable&gt;::
<span class="lineNum">     583 </span><span class="lineCov">          4 :         __uninit_default_n(__first, __n);</span>
<span class="lineNum">     584 </span>            :     }
<span class="lineNum">     585 </span>            : 
<span class="lineNum">     586 </span>            : 
<span class="lineNum">     587 </span>            :   // __uninitialized_default_a
<span class="lineNum">     588 </span>            :   // Fills [first, last) with std::distance(first, last) default
<span class="lineNum">     589 </span>            :   // constructed value_types(s), constructed with the allocator alloc.
<span class="lineNum">     590 </span>            :   template&lt;typename _ForwardIterator, typename _Allocator&gt;
<span class="lineNum">     591 </span>            :     void
<span class="lineNum">     592 </span>            :     __uninitialized_default_a(_ForwardIterator __first,
<span class="lineNum">     593 </span>            :                               _ForwardIterator __last,
<span class="lineNum">     594 </span>            :                               _Allocator&amp; __alloc)
<span class="lineNum">     595 </span>            :     {
<span class="lineNum">     596 </span>            :       _ForwardIterator __cur = __first;
<span class="lineNum">     597 </span>            :       __try
<span class="lineNum">     598 </span>            :         {
<span class="lineNum">     599 </span>            :           typedef __gnu_cxx::__alloc_traits&lt;_Allocator&gt; __traits;
<span class="lineNum">     600 </span>            :           for (; __cur != __last; ++__cur)
<span class="lineNum">     601 </span>            :             __traits::construct(__alloc, std::__addressof(*__cur));
<span class="lineNum">     602 </span>            :         }
<span class="lineNum">     603 </span>            :       __catch(...)
<span class="lineNum">     604 </span>            :         {
<span class="lineNum">     605 </span>            :           std::_Destroy(__first, __cur, __alloc);
<span class="lineNum">     606 </span>            :           __throw_exception_again;
<span class="lineNum">     607 </span>            :         }
<span class="lineNum">     608 </span>            :     }
<span class="lineNum">     609 </span>            : 
<span class="lineNum">     610 </span>            :   template&lt;typename _ForwardIterator, typename _Tp&gt;
<span class="lineNum">     611 </span>            :     inline void
<span class="lineNum">     612 </span>            :     __uninitialized_default_a(_ForwardIterator __first,
<span class="lineNum">     613 </span>            :                               _ForwardIterator __last,
<span class="lineNum">     614 </span>            :                               allocator&lt;_Tp&gt;&amp;)
<span class="lineNum">     615 </span>            :     { std::__uninitialized_default(__first, __last); }
<span class="lineNum">     616 </span>            : 
<span class="lineNum">     617 </span>            : 
<span class="lineNum">     618 </span>            :   // __uninitialized_default_n_a
<span class="lineNum">     619 </span>            :   // Fills [first, first + n) with n default constructed value_types(s),
<span class="lineNum">     620 </span>            :   // constructed with the allocator alloc.
<span class="lineNum">     621 </span>            :   template&lt;typename _ForwardIterator, typename _Size, typename _Allocator&gt;
<span class="lineNum">     622 </span>            :     _ForwardIterator
<span class="lineNum">     623 </span>            :     __uninitialized_default_n_a(_ForwardIterator __first, _Size __n, 
<span class="lineNum">     624 </span>            :                                 _Allocator&amp; __alloc)
<span class="lineNum">     625 </span>            :     {
<span class="lineNum">     626 </span>            :       _ForwardIterator __cur = __first;
<span class="lineNum">     627 </span>            :       __try
<span class="lineNum">     628 </span>            :         {
<span class="lineNum">     629 </span>            :           typedef __gnu_cxx::__alloc_traits&lt;_Allocator&gt; __traits;
<span class="lineNum">     630 </span>            :           for (; __n &gt; 0; --__n, ++__cur)
<span class="lineNum">     631 </span>            :             __traits::construct(__alloc, std::__addressof(*__cur));
<span class="lineNum">     632 </span>            :           return __cur;
<span class="lineNum">     633 </span>            :         }
<span class="lineNum">     634 </span>            :       __catch(...)
<span class="lineNum">     635 </span>            :         {
<span class="lineNum">     636 </span>            :           std::_Destroy(__first, __cur, __alloc);
<span class="lineNum">     637 </span>            :           __throw_exception_again;
<span class="lineNum">     638 </span>            :         }
<span class="lineNum">     639 </span>            :     }
<span class="lineNum">     640 </span>            : 
<a name="641"><span class="lineNum">     641 </span>            :   template&lt;typename _ForwardIterator, typename _Size, typename _Tp&gt;</a>
<span class="lineNum">     642 </span>            :     inline _ForwardIterator
<span class="lineNum">     643 </span><span class="lineCov">          4 :     __uninitialized_default_n_a(_ForwardIterator __first, _Size __n, </span>
<span class="lineNum">     644 </span>            :                                 allocator&lt;_Tp&gt;&amp;)
<span class="lineNum">     645 </span><span class="lineCov">          4 :     { return std::__uninitialized_default_n(__first, __n); }</span>
<span class="lineNum">     646 </span>            : 
<span class="lineNum">     647 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     648 </span>            :     struct __uninitialized_default_novalue_1
<span class="lineNum">     649 </span>            :     {
<span class="lineNum">     650 </span>            :       template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     651 </span>            :         static void
<span class="lineNum">     652 </span>            :         __uninit_default_novalue(_ForwardIterator __first,
<span class="lineNum">     653 </span>            :                                  _ForwardIterator __last)
<span class="lineNum">     654 </span>            :         {
<span class="lineNum">     655 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     656 </span>            :           __try
<span class="lineNum">     657 </span>            :             {
<span class="lineNum">     658 </span>            :               for (; __cur != __last; ++__cur)
<span class="lineNum">     659 </span>            :                 std::_Construct_novalue(std::__addressof(*__cur));
<span class="lineNum">     660 </span>            :             }
<span class="lineNum">     661 </span>            :           __catch(...)
<span class="lineNum">     662 </span>            :             {
<span class="lineNum">     663 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     664 </span>            :               __throw_exception_again;
<span class="lineNum">     665 </span>            :             }
<span class="lineNum">     666 </span>            :         }
<span class="lineNum">     667 </span>            :     };
<span class="lineNum">     668 </span>            : 
<span class="lineNum">     669 </span>            :   template&lt;&gt;
<span class="lineNum">     670 </span>            :     struct __uninitialized_default_novalue_1&lt;true&gt;
<span class="lineNum">     671 </span>            :     {
<span class="lineNum">     672 </span>            :       template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     673 </span>            :         static void
<span class="lineNum">     674 </span>            :         __uninit_default_novalue(_ForwardIterator __first,
<span class="lineNum">     675 </span>            :                                  _ForwardIterator __last)
<span class="lineNum">     676 </span>            :         {
<span class="lineNum">     677 </span>            :         }
<span class="lineNum">     678 </span>            :     };
<span class="lineNum">     679 </span>            : 
<span class="lineNum">     680 </span>            :   template&lt;bool _TrivialValueType&gt;
<span class="lineNum">     681 </span>            :     struct __uninitialized_default_novalue_n_1
<span class="lineNum">     682 </span>            :     {
<span class="lineNum">     683 </span>            :       template&lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     684 </span>            :         static _ForwardIterator
<span class="lineNum">     685 </span>            :         __uninit_default_novalue_n(_ForwardIterator __first, _Size __n)
<span class="lineNum">     686 </span>            :         {
<span class="lineNum">     687 </span>            :           _ForwardIterator __cur = __first;
<span class="lineNum">     688 </span>            :           __try
<span class="lineNum">     689 </span>            :             {
<span class="lineNum">     690 </span>            :               for (; __n &gt; 0; --__n, ++__cur)
<span class="lineNum">     691 </span>            :                 std::_Construct_novalue(std::__addressof(*__cur));
<span class="lineNum">     692 </span>            :               return __cur;
<span class="lineNum">     693 </span>            :             }
<span class="lineNum">     694 </span>            :           __catch(...)
<span class="lineNum">     695 </span>            :             {
<span class="lineNum">     696 </span>            :               std::_Destroy(__first, __cur);
<span class="lineNum">     697 </span>            :               __throw_exception_again;
<span class="lineNum">     698 </span>            :             }
<span class="lineNum">     699 </span>            :         }
<span class="lineNum">     700 </span>            :     };
<span class="lineNum">     701 </span>            : 
<span class="lineNum">     702 </span>            :   template&lt;&gt;
<span class="lineNum">     703 </span>            :     struct __uninitialized_default_novalue_n_1&lt;true&gt;
<span class="lineNum">     704 </span>            :     {
<span class="lineNum">     705 </span>            :       template&lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     706 </span>            :         static _ForwardIterator
<span class="lineNum">     707 </span>            :         __uninit_default_novalue_n(_ForwardIterator __first, _Size __n)
<span class="lineNum">     708 </span>            :         { return std::next(__first, __n); }
<span class="lineNum">     709 </span>            :     };
<span class="lineNum">     710 </span>            : 
<span class="lineNum">     711 </span>            :   // __uninitialized_default_novalue
<span class="lineNum">     712 </span>            :   // Fills [first, last) with std::distance(first, last) default-initialized
<span class="lineNum">     713 </span>            :   // value_types(s).
<span class="lineNum">     714 </span>            :   template&lt;typename _ForwardIterator&gt;
<span class="lineNum">     715 </span>            :     inline void
<span class="lineNum">     716 </span>            :     __uninitialized_default_novalue(_ForwardIterator __first,
<span class="lineNum">     717 </span>            :                                     _ForwardIterator __last)
<span class="lineNum">     718 </span>            :     {
<span class="lineNum">     719 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     720 </span>            :         _ValueType;
<span class="lineNum">     721 </span>            : 
<span class="lineNum">     722 </span>            :       std::__uninitialized_default_novalue_1&lt;
<span class="lineNum">     723 </span>            :         is_trivially_default_constructible&lt;_ValueType&gt;::value&gt;::
<span class="lineNum">     724 </span>            :         __uninit_default_novalue(__first, __last);
<span class="lineNum">     725 </span>            :     }
<span class="lineNum">     726 </span>            : 
<span class="lineNum">     727 </span>            :   // __uninitialized_default_n
<span class="lineNum">     728 </span>            :   // Fills [first, first + n) with n default-initialized value_type(s).
<span class="lineNum">     729 </span>            :   template&lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     730 </span>            :     inline _ForwardIterator
<span class="lineNum">     731 </span>            :     __uninitialized_default_novalue_n(_ForwardIterator __first, _Size __n)
<span class="lineNum">     732 </span>            :     {
<span class="lineNum">     733 </span>            :       typedef typename iterator_traits&lt;_ForwardIterator&gt;::value_type
<span class="lineNum">     734 </span>            :         _ValueType;
<span class="lineNum">     735 </span>            : 
<span class="lineNum">     736 </span>            :       return __uninitialized_default_novalue_n_1&lt;
<span class="lineNum">     737 </span>            :         is_trivially_default_constructible&lt;_ValueType&gt;::value&gt;::
<span class="lineNum">     738 </span>            :         __uninit_default_novalue_n(__first, __n);
<span class="lineNum">     739 </span>            :     }
<span class="lineNum">     740 </span>            : 
<span class="lineNum">     741 </span>            :   template&lt;typename _InputIterator, typename _Size,
<span class="lineNum">     742 </span>            :            typename _ForwardIterator&gt;
<span class="lineNum">     743 </span>            :     _ForwardIterator
<span class="lineNum">     744 </span>            :     __uninitialized_copy_n(_InputIterator __first, _Size __n,
<span class="lineNum">     745 </span>            :                            _ForwardIterator __result, input_iterator_tag)
<span class="lineNum">     746 </span>            :     {
<span class="lineNum">     747 </span>            :       _ForwardIterator __cur = __result;
<span class="lineNum">     748 </span>            :       __try
<span class="lineNum">     749 </span>            :         {
<span class="lineNum">     750 </span>            :           for (; __n &gt; 0; --__n, ++__first, ++__cur)
<span class="lineNum">     751 </span>            :             std::_Construct(std::__addressof(*__cur), *__first);
<span class="lineNum">     752 </span>            :           return __cur;
<span class="lineNum">     753 </span>            :         }
<span class="lineNum">     754 </span>            :       __catch(...)
<span class="lineNum">     755 </span>            :         {
<span class="lineNum">     756 </span>            :           std::_Destroy(__result, __cur);
<span class="lineNum">     757 </span>            :           __throw_exception_again;
<span class="lineNum">     758 </span>            :         }
<span class="lineNum">     759 </span>            :     }
<span class="lineNum">     760 </span>            : 
<span class="lineNum">     761 </span>            :   template&lt;typename _RandomAccessIterator, typename _Size,
<span class="lineNum">     762 </span>            :            typename _ForwardIterator&gt;
<span class="lineNum">     763 </span>            :     inline _ForwardIterator
<span class="lineNum">     764 </span>            :     __uninitialized_copy_n(_RandomAccessIterator __first, _Size __n,
<span class="lineNum">     765 </span>            :                            _ForwardIterator __result,
<span class="lineNum">     766 </span>            :                            random_access_iterator_tag)
<span class="lineNum">     767 </span>            :     { return std::uninitialized_copy(__first, __first + __n, __result); }
<span class="lineNum">     768 </span>            : 
<span class="lineNum">     769 </span>            :   template&lt;typename _InputIterator, typename _Size,
<span class="lineNum">     770 </span>            :            typename _ForwardIterator&gt;
<span class="lineNum">     771 </span>            :     pair&lt;_InputIterator, _ForwardIterator&gt;
<span class="lineNum">     772 </span>            :     __uninitialized_copy_n_pair(_InputIterator __first, _Size __n,
<span class="lineNum">     773 </span>            :                            _ForwardIterator __result, input_iterator_tag)
<span class="lineNum">     774 </span>            :     {
<span class="lineNum">     775 </span>            :       _ForwardIterator __cur = __result;
<span class="lineNum">     776 </span>            :       __try
<span class="lineNum">     777 </span>            :         {
<span class="lineNum">     778 </span>            :           for (; __n &gt; 0; --__n, ++__first, ++__cur)
<span class="lineNum">     779 </span>            :             std::_Construct(std::__addressof(*__cur), *__first);
<span class="lineNum">     780 </span>            :           return {__first, __cur};
<span class="lineNum">     781 </span>            :         }
<span class="lineNum">     782 </span>            :       __catch(...)
<span class="lineNum">     783 </span>            :         {
<span class="lineNum">     784 </span>            :           std::_Destroy(__result, __cur);
<span class="lineNum">     785 </span>            :           __throw_exception_again;
<span class="lineNum">     786 </span>            :         }
<span class="lineNum">     787 </span>            :     }
<span class="lineNum">     788 </span>            : 
<span class="lineNum">     789 </span>            :   template&lt;typename _RandomAccessIterator, typename _Size,
<span class="lineNum">     790 </span>            :            typename _ForwardIterator&gt;
<span class="lineNum">     791 </span>            :     inline pair&lt;_RandomAccessIterator, _ForwardIterator&gt;
<span class="lineNum">     792 </span>            :     __uninitialized_copy_n_pair(_RandomAccessIterator __first, _Size __n,
<span class="lineNum">     793 </span>            :                            _ForwardIterator __result,
<span class="lineNum">     794 </span>            :                            random_access_iterator_tag)
<span class="lineNum">     795 </span>            :     {
<span class="lineNum">     796 </span>            :       auto __second_res = uninitialized_copy(__first, __first + __n, __result);
<span class="lineNum">     797 </span>            :       auto __first_res = std::next(__first, __n);
<span class="lineNum">     798 </span>            :       return {__first_res, __second_res};
<span class="lineNum">     799 </span>            :     }
<span class="lineNum">     800 </span>            : 
<span class="lineNum">     801 </span>            :   /**
<span class="lineNum">     802 </span>            :    *  @brief Copies the range [first,first+n) into result.
<span class="lineNum">     803 </span>            :    *  @param  __first  An input iterator.
<span class="lineNum">     804 </span>            :    *  @param  __n      The number of elements to copy.
<span class="lineNum">     805 </span>            :    *  @param  __result An output iterator.
<span class="lineNum">     806 </span>            :    *  @return  __result + __n
<span class="lineNum">     807 </span>            :    *
<span class="lineNum">     808 </span>            :    *  Like copy_n(), but does not require an initialized output range.
<span class="lineNum">     809 </span>            :   */
<span class="lineNum">     810 </span>            :   template&lt;typename _InputIterator, typename _Size, typename _ForwardIterator&gt;
<span class="lineNum">     811 </span>            :     inline _ForwardIterator
<span class="lineNum">     812 </span>            :     uninitialized_copy_n(_InputIterator __first, _Size __n,
<span class="lineNum">     813 </span>            :                          _ForwardIterator __result)
<span class="lineNum">     814 </span>            :     { return std::__uninitialized_copy_n(__first, __n, __result,
<span class="lineNum">     815 </span>            :                                          std::__iterator_category(__first)); }
<span class="lineNum">     816 </span>            : 
<span class="lineNum">     817 </span>            :   template&lt;typename _InputIterator, typename _Size, typename _ForwardIterator&gt;
<span class="lineNum">     818 </span>            :     inline pair&lt;_InputIterator, _ForwardIterator&gt;
<span class="lineNum">     819 </span>            :     __uninitialized_copy_n_pair(_InputIterator __first, _Size __n,
<span class="lineNum">     820 </span>            :                               _ForwardIterator __result)
<span class="lineNum">     821 </span>            :     {
<span class="lineNum">     822 </span>            :       return
<span class="lineNum">     823 </span>            :         std::__uninitialized_copy_n_pair(__first, __n, __result,
<span class="lineNum">     824 </span>            :                                          std::__iterator_category(__first));
<span class="lineNum">     825 </span>            :     }
<span class="lineNum">     826 </span>            : 
<span class="lineNum">     827 </span>            : #endif
<span class="lineNum">     828 </span>            : 
<span class="lineNum">     829 </span>            : #if __cplusplus &gt; 201402L
<span class="lineNum">     830 </span>            :   template &lt;typename _ForwardIterator&gt;
<span class="lineNum">     831 </span>            :     inline void
<span class="lineNum">     832 </span>            :     uninitialized_default_construct(_ForwardIterator __first,
<span class="lineNum">     833 </span>            :                                     _ForwardIterator __last)
<span class="lineNum">     834 </span>            :     {
<span class="lineNum">     835 </span>            :       __uninitialized_default_novalue(__first, __last);
<span class="lineNum">     836 </span>            :     }
<span class="lineNum">     837 </span>            : 
<span class="lineNum">     838 </span>            :   template &lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     839 </span>            :     inline _ForwardIterator
<span class="lineNum">     840 </span>            :     uninitialized_default_construct_n(_ForwardIterator __first, _Size __count)
<span class="lineNum">     841 </span>            :     {
<span class="lineNum">     842 </span>            :       return __uninitialized_default_novalue_n(__first, __count);
<span class="lineNum">     843 </span>            :     }
<span class="lineNum">     844 </span>            : 
<span class="lineNum">     845 </span>            :   template &lt;typename _ForwardIterator&gt;
<span class="lineNum">     846 </span>            :     inline void
<span class="lineNum">     847 </span>            :     uninitialized_value_construct(_ForwardIterator __first,
<span class="lineNum">     848 </span>            :                                   _ForwardIterator __last)
<span class="lineNum">     849 </span>            :     {
<span class="lineNum">     850 </span>            :       return __uninitialized_default(__first, __last);
<span class="lineNum">     851 </span>            :     }
<span class="lineNum">     852 </span>            : 
<span class="lineNum">     853 </span>            :   template &lt;typename _ForwardIterator, typename _Size&gt;
<span class="lineNum">     854 </span>            :     inline _ForwardIterator
<span class="lineNum">     855 </span>            :     uninitialized_value_construct_n(_ForwardIterator __first, _Size __count)
<span class="lineNum">     856 </span>            :     {
<span class="lineNum">     857 </span>            :       return __uninitialized_default_n(__first, __count);
<span class="lineNum">     858 </span>            :     }
<span class="lineNum">     859 </span>            : 
<span class="lineNum">     860 </span>            :   template &lt;typename _InputIterator, typename _ForwardIterator&gt;
<span class="lineNum">     861 </span>            :     inline _ForwardIterator
<span class="lineNum">     862 </span>            :     uninitialized_move(_InputIterator __first, _InputIterator __last,
<span class="lineNum">     863 </span>            :                        _ForwardIterator __result)
<span class="lineNum">     864 </span>            :     {
<span class="lineNum">     865 </span>            :       return std::uninitialized_copy
<span class="lineNum">     866 </span>            :         (_GLIBCXX_MAKE_MOVE_ITERATOR(__first),
<span class="lineNum">     867 </span>            :          _GLIBCXX_MAKE_MOVE_ITERATOR(__last), __result);
<span class="lineNum">     868 </span>            :     }
<span class="lineNum">     869 </span>            : 
<span class="lineNum">     870 </span>            :   template &lt;typename _InputIterator, typename _Size, typename _ForwardIterator&gt;
<span class="lineNum">     871 </span>            :     inline pair&lt;_InputIterator, _ForwardIterator&gt;
<span class="lineNum">     872 </span>            :     uninitialized_move_n(_InputIterator __first, _Size __count,
<span class="lineNum">     873 </span>            :                          _ForwardIterator __result)
<span class="lineNum">     874 </span>            :     {
<span class="lineNum">     875 </span>            :       auto __res = std::__uninitialized_copy_n_pair
<span class="lineNum">     876 </span>            :         (_GLIBCXX_MAKE_MOVE_ITERATOR(__first),
<span class="lineNum">     877 </span>            :          __count, __result);
<span class="lineNum">     878 </span>            :       return {__res.first.base(), __res.second};
<span class="lineNum">     879 </span>            :     }
<span class="lineNum">     880 </span>            : #endif
<span class="lineNum">     881 </span>            : 
<span class="lineNum">     882 </span>            : _GLIBCXX_END_NAMESPACE_VERSION
<span class="lineNum">     883 </span>            : } // namespace
<span class="lineNum">     884 </span>            : 
<span class="lineNum">     885 </span>            : #endif /* _STL_UNINITIALIZED_H */
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../../../../../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.13</a></td></tr>
  </table>
  <br>

</body>
</html>
